#include <chrono>
#include <future>
#include <iostream>

void calcul(std::promise<double> valeur1,std::promise<double> valeur2) {
 std::this_thread::sleep_for(std::chrono::seconds(1));
 valeur1.set_value(3);
 std::this_thread::sleep_for(std::chrono::seconds(1));
 valeur2.set_value(7);
}

int main(void) {
 std::promise<double> valeur1;
 std::promise<double> valeur2;

 std::future<double> f1 = valeur1.get_future();
 std::future<double> f2 = valeur2.get_future();

 std::future<void> f = std::async(std::launch::async,calcul,std::move(valeur1),std::move(valeur2));

 f1.wait();
 std::cout << "valeur1 = " << f1.get() << std::endl;
 f2.wait();
 std::cout << "valeur2 = " << f2.get() << std::endl;
}
