#include <chrono>
#include <future>
#include <iostream>
#include <mutex>

std::mutex mutex;

void zzz(unsigned n) {
 mutex.lock();
 std::cout << "[" << n << "] zzz..." << std::endl;
 mutex.unlock();
 std::this_thread::sleep_for(std::chrono::seconds(1));
}

int main(void) {
 std::future<void> f[4];

 for (unsigned i = 0; i<4; ++i) f[i] = async(std::launch::async,zzz,i);
}
