#include <chrono>
#include <future>
#include <iostream>

double calcul(unsigned n) {
 std::this_thread::sleep_for(std::chrono::seconds(1));
 return (n+1)*(n+1);
}

int main(void) {
 std::future<double> f[4];
 double somme = 0;

 for (unsigned i = 0; i<4; ++i) f[i] = std::async(std::launch::async,calcul,i);
 for (unsigned i = 0; i<4; ++i) somme += f[i].get();

 std::cout << "resultat = " << somme << std::endl;
}
