#include <condition_variable>
#include <iostream>
#include <mutex>
#include <thread>

std::condition_variable condition;
std::mutex              mutex;
unsigned                compteur = 0;

void esclave(unsigned n) {
 std::unique_lock<std::mutex> verrou(mutex);
 std::cout << "[" << n << "] attend..." << std::endl;
 condition.wait(verrou,[](){ return compteur==5; });
 std::cout << "[" << n << "] termine" << std::endl;
}

void maitre(void) {
 for (unsigned i = 0; i<5; ++i) {
  { std::lock_guard<std::mutex> verrou(mutex);
    std::cout << "[0] compteur = " << compteur << std::endl; }

  std::this_thread::sleep_for(std::chrono::seconds(1));

  { std::lock_guard<std::mutex> verrou(mutex);
    ++compteur; }

  condition.notify_all();
 }
}

int main(void) {
 std::thread t[4];

 t[0] = std::thread(maitre);
 for (unsigned i = 1; i<4; ++i) t[i] = std::thread(esclave,i+1);
 for (unsigned i = 0; i<4; ++i) t[i].join();
}
